#!/usr/bin/perl

# $Id: getsoa.pl,v 1.2 2005/05/11 00:08:50 vixie Exp $

use strict;
use Net::DNS;

die "please upgrade Net::DNS to version >= 0.45"
	unless Net::DNS->version >= 0.45;

my ($mz, $ns) = @ARGV;
die "usage: $0 metazone nameserver" unless length $mz && length $ns;

my $res = Net::DNS::Resolver->new;
$res->nameservers($ns);
my $soa = $res->query($mz, "SOA");
die $res->errorstring unless $soa;

my @soalist = grep { $_->type eq 'SOA' } $soa->answer;
die "format error" unless $#soalist == $[;

(my $rdata) = @soalist;
print $rdata->serial, "\n";

exit 0;
