#! /bin/sh

# $Id: mz.sh,v 1.5 2005/12/19 19:08:10 vixie Exp $

. etc/config.default
. etc/config

reconfig=0
mz() {
	local newsoa oldsoa mz ns dn

	mz=$1
	ns=$2
	dn=$3

	newsoa=$(perl bin/getsoa.pl $mz $ns)
	test $? -eq 0 || {
		echo $0: cannot get new soa from $ns for $mz
		return 1
	}
	if [ -f var/$mz.soa ]; then
		oldsoa=$(cat var/$mz.soa)
		test $oldsoa -eq $newsoa && return 0
	fi
	rm -f var/$mz.new
	eval "perl bin/mzg.pl $mz $ns $dn ${others:-}" > var/$mz.new || {
		echo $0: cannot regen incl file for $mz
		return 1
	}
	mv var/$mz.new var/$mz.inc || {
		echo $0: cannot move new include file for $mz
		return 1
	}
	echo $newsoa > var/$mz.new
	mv var/$mz.new var/$mz.soa || {
		echo $0: cannot move new soa file for $mz
		return 1
	}
	reconfig=1
	return 0
}

rm -f var/all.inc.new
egrep -v '^$|^#' etc/zones | while read mz; do
	case X$mz in
	X) continue ;;
	X#*) continue ;;
	esac

	mkdir -p $dn/$mz
	if mz $mz $ns $dn/$mz; then
		echo include \"`pwd`/var/$mz.inc\"\; >> var/all.inc.new
	else
		echo $0: mz $mz failed, no config change will occur
	fi
done

if cmp -s var/all.inc var/all.inc.new; then
	rm -f var/all.inc.new
else
	[ -f var/all.inc ] && mv var/all.inc var/all.inc.old
	mv var/all.inc.new var/all.inc
fi

if [ $reconfig -ne 0 ]; then
	$rndc reconfig || {
		echo $0: cannot rndc-reconfig after new `pwd`/var/all.inc
		exit 1
	}
fi

exit 0
